/********************************************************
ColorRectangle	class	v1.0
Viktor Goltvyanitsa
http://www.fwkit.com
********************************************************/
class com.fwkit.color.ColorRectangle {
		static var version:String = "1.0.0.1";
		
		private var lineColor:String = "";
		private var lineAlpha:Number = 0;
		private var lineStroke:Number = 0;
		private var fillColor:String;
		private var fillAlpha:Number;
		private var docWidth:Number = 0;
		private var docHeight:Number = 0;
		private var initX:Number=0;
		private var initY:Number=0;
		private var pointX:Number;
		private var pointY:Number;
		private var metaClip:MovieClip;
	
		public function ColorRectangle (_TARGETCLIP:MovieClip,_CRDX:Number,_CRDY:Number,_LINECOLOR:String,_LINEALPHA:Number,_LINESTROKE:Number,_fillColor:String,_fillAlpha:Number,_DOCWIDTH:Number,_DOCHEIGHT:Number){
						metaClip=_TARGETCLIP;
						initX=_CRDX;
						initY=_CRDY;

						lineColor = _LINECOLOR;
						lineAlpha = _LINEALPHA;
						lineStroke = _LINESTROKE;
						fillColor=_fillColor;
						fillAlpha=_fillAlpha;
						docWidth = _DOCWIDTH;
						docHeight = _DOCHEIGHT;

						drawRectangle(metaClip,initX,initY,docWidth-lineStroke,docHeight-lineStroke,lineStroke,"0x"+lineColor,"0x"+fillColor,lineAlpha,fillAlpha);
			}
			
		public function drawRectangle(targetClip,crdX:Number,crdY:Number,SquareWidth:Number,SquareHeight:Number,thicknessLine:Number,colorLine:String,colorFil:String,alphaLine:Number,alphaFill:Number):Void{
					if(thicknessLine==undefined){thicknessLine=1};
					if(colorLine==undefined){colorLine="0xffffff"};
					if(colorFil==undefined){colorFil="0xffffff"};
					if(alphaLine==undefined){alphaLine=100};
					if(alphaFill==undefined){alphaFill=100};
					if(thicknessLine>0){
						pointX=crdX+(thicknessLine/2);
						pointY=crdY+(thicknessLine/2);						
					}else{
						pointX=crdX;
						pointY=crdY;								
					}
					targetClip.clear();
					targetClip.lineStyle(thicknessLine,colorLine,alphaLine);
					targetClip.beginFill(colorFil,alphaFill);
					targetClip.moveTo(pointX,pointY);
					targetClip.lineTo(pointX+SquareWidth,pointY);
					targetClip.lineTo(pointX+SquareWidth,pointY+SquareHeight);
					targetClip.lineTo(pointX,pointY+SquareHeight);
					targetClip.endFill();
		}
		
		public function setSize(w:Number,h:Number,minW:Number,minH:Number):Void{
			if(minW!=undefined&&minH!=undefined){
				if(w>minW){
					docWidth = w;
				}
				if(h>minH){
					docHeight = h;
				}
					refresh();				
			}else{
					docWidth = w;
					docHeight = h;
					refresh();
			}
		}
		
		public function setOver():Void{
			drawRectangle(metaClip,initX,initY,docWidth-lineStroke,docHeight-1,1,"0x666666","0x"+fillColor,100,fillAlpha);
		}
		
		public function setCenterTransparent():Void{
			drawRectangle(metaClip,initX,initY,docWidth-lineStroke,docHeight-1,1,"0x666666","0x"+fillColor,100,0);
		}
		
		public function setFillRGB(fillRGB:String):Void{
			fillColor=fillRGB;
		}
		
		public function setOut():Void{
			drawRectangle(metaClip,initX,initY,docWidth-lineStroke,docHeight-lineStroke,lineStroke,"0x"+lineColor,"0x"+fillColor,lineAlpha,fillAlpha);
		}
		
		public function refresh():Void{
			drawRectangle(metaClip,initX,initY,docWidth-lineStroke,docHeight-lineStroke,lineStroke,"0x"+lineColor,"0x"+fillColor,lineAlpha,fillAlpha);
		}
		
		public function getWidth():Number{
			return docWidth;
		}
		
		public function getHeight():Number{
			return docHeight;
		}

}