/********************************************************
HLSSelector class v1.0
Viktor Goltvyanitsa
http://www.fwkit.com/
Usage:
var initColor:String="8288CB";
var cm:ColorMatch = new ColorMatch(initColor);
var cs:HLSSelector = new HLSSelector(main,240,150,cm);
********************************************************/
import com.fwkit.color.ColorRectangle;
import com.fwkit.color.ColorMatch;
class	com.fwkit.color.HLSSelector extends MovieClip {
		static var version:String = "1.0.0.0";
		private var colorsGradient:Array = [];
		private var clrLite2="DFDFE3";
		private var cm:ColorMatch;
		private var koffW:Number;
		private var koffH:Number;
		private var initialWidth:Number;
		private var initialHeight:Number;
		public var thisBaseClip:MovieClip;

	public function HLSSelector(targetClip:MovieClip,initW:Number,initH:Number,parentColorMatch:ColorMatch){
		if(targetClip!=undefined){
			thisBaseClip=targetClip;
			cm=parentColorMatch;
			thisBaseClip.createEmptyMovieClip("HLSSelector",0);
			thisBaseClip.HLSSelector.createEmptyMovieClip("point",5);
			thisBaseClip.HLSSelector.createEmptyMovieClip("gradient",0);
			thisBaseClip.HLSSelector.createEmptyMovieClip("BorderClip",10);
			
			initialWidth=initW;
			initialHeight=initH;
			setSize(initW,initH,cm);
			thisBaseClip.HLSSelector.gradient.onRelease=function(){
				this._parent.point._x=this._xmouse-(this._parent.point._width/2);
				this._parent.point._y=this._ymouse-(this._parent.point._height/2);
			}
			thisBaseClip.HLSSelector.gradient.onRollOver=function(){
				this.useHandCursor = false;
				
			}
			//-----
			thisBaseClip.HLSSelector.point.onRollOver=function(){
				this.useHandCursor = false;
				this._parent.cm.setHLS((this._x+this._width/2)/this.koffW,this._parent.cm.getHLS("byte").L,(this.totalHeight-(this._y+this._height/2))/this.koffH,"byte");
				this.pr.setFillRGB(this._parent.cm.getRGBstr());
				this.pr.setOver();
			}
			thisBaseClip.HLSSelector.point.onRollOut=function(){
				this._parent.cm.setHLS((this._x+this._width/2)/this.koffW,this._parent.cm.getHLS("byte").L,(this.totalHeight-(this._y+this._height/2))/this.koffH,"byte");
				this.pr.setFillRGB(this._parent.cm.getRGBstr());
				this.pr.setOut();
			}
			thisBaseClip.HLSSelector.point.onPress=function(){
				this.pr.setOver();
				this.pr.setCenterTransparent();
				startDrag(this, false, 1, 1, this._parent.baseWidth-this._width, this._parent.baseHeight-(this._height));
			}
			thisBaseClip.HLSSelector.point.onRelease=function(){
			this._parent.cm.setHLS((this._x+this._width/2)/this.koffW,this._parent.cm.getHLS("byte").L,(this.totalHeight-(this._y+this._height/2))/this.koffH,"byte");
			this.pr.setFillRGB(this._parent.cm.getRGBstr());
			//trace(this._parent.cm.getRGBstr());
				this.stopDrag();
				this.pr.setOut();
			}
			thisBaseClip.HLSSelector.point.onReleaseOutside=function(){
			this._parent.cm.setHLS((this._x+this._width/2)/this.koffW,this._parent.cm.getHLS("byte").L,(this.totalHeight-(this._y+this._height/2))/this.koffH,"byte");
			this.pr.setFillRGB(this._parent.cm.getRGBstr());
				this.stopDrag();
				this.pr.setOut();
			}	
			//---
		}
	}
	
	public function call():Void{
		setSize(initialWidth,initialHeight,cm);
	}
	
	public function setCoordinates(crdX:Number,crdY:Number):Void{
		thisBaseClip._x = crdX;
		thisBaseClip._y = crdY;
	}
	
	private function setPointSelectorCoordinates(clip:MovieClip,totalWidth:Number,totalHeight:Number):Void{
			var initColor:Object=new Object();
			initColor=cm.getHLS("byte");
			koffW=totalWidth/255;
			koffH=totalHeight/255;
			clip.koffW=koffW;
			clip.koffH=koffH;
			clip.totalHeight=totalHeight;
			clip._x=(initColor.H*koffW)-clip._width/2;
			clip._y=(totalHeight-initColor.S*koffH)-clip._height/2;
	}
	
	private function setPointSelector():Void{
		thisBaseClip.HLSSelector.point.clear();
		var pointRectangle:ColorRectangle = new ColorRectangle(thisBaseClip.HLSSelector.point,0,0,"000000", 60, 2,cm.getRGBstr(),100,10,10);
		thisBaseClip.HLSSelector.point.pr=pointRectangle;
	}
	
	private function setGradientLightness(targetLightness:Number):Void{
		var newColorMatch:ColorMatch=new ColorMatch();
		for(var i=0;i<7;i++){
			newColorMatch.setHLS(i*60, targetLightness, 255, "degree_byte")
			colorsGradient[i]=Number("0x"+newColorMatch.getRGBstr());			
		}
	}
	
	public function setSize(targW:Number,targH:Number,parentColorMatch:ColorMatch):Void{
					cm=parentColorMatch;
					thisBaseClip.HLSSelector.cm=parentColorMatch;
					var heightMain:Number=targH-1;
					var widthMain:Number=targW-3;
					var widthTemp1:Number=widthMain/6;
					var widthTemp2:Number=widthTemp1/2;
					var heightTemp1:Number = heightMain/2;
					initialWidth=targW;
					initialHeight=targH;
					thisBaseClip.HLSSelector.gradient.clear();
					thisBaseClip.HLSSelector.baseWidth=widthMain;
					thisBaseClip.HLSSelector.baseHeight=heightMain;
					
					setGradientLightness(cm.getHLS("byte").L);
					var si:Object= {
									lineWidth:3,
									startX:2,
									startY:2,
									clrLite2:clrLite2,
									alpha:100,
									widthMain:widthMain,
									heightMain:heightMain,
									widthTemp1:widthTemp1,
									widthTemp2:widthTemp2,
									heightTemp1:heightTemp1,
									colorsGradient:colorsGradient
								};
							gradientDrawing(si);
							si.startX = 6;
							si.startY = 53;
							
							squareDrawing(si);
							setPointSelector();
							setPointSelectorCoordinates(thisBaseClip.HLSSelector.point,widthMain,heightMain);
				delete widthTemp1;
				delete widthTemp2;
				delete heightTemp1;
	}
	
	private function gradientDrawing(si:Object):Void{
				thisBaseClip.HLSSelector.gradient.lineStyle(0,"0x"+clrLite2,0);
				thisBaseClip.HLSSelector.gradient.beginGradientFill("linear",[colorsGradient[0],colorsGradient[1]], [100,100], [0,255], {a:si.widthTemp1,b:0,c:0,d:0,e:si.heightMain,f:0,g:si.startX+si.widthTemp2,h:si.heightTemp1,i:0});
				thisBaseClip.HLSSelector.gradient.moveTo(si.startX,si.startY);
				thisBaseClip.HLSSelector.gradient.lineTo(si.startX+si.widthTemp1, si.startY);
				thisBaseClip.HLSSelector.gradient.lineTo(si.startX+si.widthTemp1, si.heightMain);
				thisBaseClip.HLSSelector.gradient.lineTo(si.startX, si.heightMain);
				thisBaseClip.HLSSelector.gradient.lineTo(si.startX, si.startY);
				thisBaseClip.HLSSelector.gradient.endFill();
			//***
				thisBaseClip.HLSSelector.gradient.lineStyle(0,"0x"+clrLite2,0);
				thisBaseClip.HLSSelector.gradient.beginGradientFill("linear",[colorsGradient[1],colorsGradient[2]], [100,100], [0,255],{a:si.widthTemp1,b:0,c:0,d:0,e:si.heightMain,f:0,g:si.startX+si.widthTemp1+si.widthTemp2,h:si.heightTemp1,i:0});
				thisBaseClip.HLSSelector.gradient.moveTo(si.startX+si.widthTemp1,si.startY);
				thisBaseClip.HLSSelector.gradient.lineTo(si.startX+(2*si.widthTemp1),si.startY);
				thisBaseClip.HLSSelector.gradient.lineTo(si.startX+(2*si.widthTemp1),si.heightMain);
				thisBaseClip.HLSSelector.gradient.lineTo(si.startX+si.widthTemp1,	si.heightMain);
				thisBaseClip.HLSSelector.gradient.lineTo(si.startX+si.widthTemp1,si.startY);
				thisBaseClip.HLSSelector.gradient.endFill();
			//***
				thisBaseClip.HLSSelector.gradient.lineStyle(0,"0x"+clrLite2,0);
				thisBaseClip.HLSSelector.gradient.beginGradientFill("linear",[colorsGradient[2],colorsGradient[3]], [100,100], [0,255], {a:si.widthTemp1,b:0,c:0,d:0,e:si.heightMain,f:0,g:si.startX+2*si.widthTemp1+si.widthTemp2,h:si.heightTemp1,i:0});
				thisBaseClip.HLSSelector.gradient.moveTo(si.startX+2*si.widthTemp1,si.startY);
				thisBaseClip.HLSSelector.gradient.lineTo(si.startX+(3*si.widthTemp1),si.startY);
				thisBaseClip.HLSSelector.gradient.lineTo(si.startX+(3*si.widthTemp1),si.heightMain);
				thisBaseClip.HLSSelector.gradient.lineTo(si.startX+2*si.widthTemp1,si.heightMain);
				thisBaseClip.HLSSelector.gradient.lineTo(si.startX+2*si.widthTemp1,si.startY);
				thisBaseClip.HLSSelector.gradient.endFill();						
			//***
				thisBaseClip.HLSSelector.gradient.lineStyle(0,"0x"+clrLite2,0);
				thisBaseClip.HLSSelector.gradient.beginGradientFill("linear",[colorsGradient[3],colorsGradient[4]],[100,	100],[0,255],{a:si.widthTemp1,b:0,c:0,d:0,e:si.heightMain,f:0,g:si.startX+3*si.widthTemp1+si.widthTemp2,h:si.heightTemp1,i:0});
				thisBaseClip.HLSSelector.gradient.moveTo(si.startX+3*si.widthTemp1, si.startY);
				thisBaseClip.HLSSelector.gradient.lineTo(si.startX+(4*si.widthTemp1), si.startY);
				thisBaseClip.HLSSelector.gradient.lineTo(si.startX+(4*si.widthTemp1), si.heightMain);
				thisBaseClip.HLSSelector.gradient.lineTo(si.startX+3*si.widthTemp1, si.heightMain);
				thisBaseClip.HLSSelector.gradient.lineTo(si.startX+3*si.widthTemp1, si.startY);
				thisBaseClip.HLSSelector.gradient.endFill();
			//***
				thisBaseClip.HLSSelector.gradient.lineStyle(0,"0x"+clrLite2,0);
				thisBaseClip.HLSSelector.gradient.beginGradientFill("linear",[colorsGradient[4],colorsGradient[5]], [100,100],[0,255],{a:si.widthTemp1,b:0,c:0,d:0,e:si.heightMain,f:0,g:si.startX+4*si.widthTemp1+si.widthTemp2,h:si.heightTemp1,i:0});
				thisBaseClip.HLSSelector.gradient.moveTo(si.startX+4*si.widthTemp1, si.startY);
				thisBaseClip.HLSSelector.gradient.lineTo(si.startX+(5*si.widthTemp1), si.startY);
				thisBaseClip.HLSSelector.gradient.lineTo(si.startX+(5*si.widthTemp1), si.heightMain);
				thisBaseClip.HLSSelector.gradient.lineTo(si.startX+4*si.widthTemp1, si.heightMain);
				thisBaseClip.HLSSelector.gradient.lineTo(si.startX+4*si.widthTemp1, si.startY);
				thisBaseClip.HLSSelector.gradient.endFill();
			//***
				thisBaseClip.HLSSelector.gradient.lineStyle(0,"0x"+clrLite2,0);
				thisBaseClip.HLSSelector.gradient.beginGradientFill("linear",[colorsGradient[5],colorsGradient[6]], [100,100], [0,255], {a:si.widthTemp1, b:0, c:0, d:0, e:si.heightMain, f:0, g:si.startX+5*si.widthTemp1+si.widthTemp2, h:si.heightTemp1, i:0});
				thisBaseClip.HLSSelector.gradient.moveTo(si.startX+5*si.widthTemp1, si.startY);
				thisBaseClip.HLSSelector.gradient.lineTo(si.startX+(6*si.widthTemp1), si.startY);
				thisBaseClip.HLSSelector.gradient.lineTo(si.startX+(6*si.widthTemp1), si.heightMain);
				thisBaseClip.HLSSelector.gradient.lineTo(si.startX+5*si.widthTemp1, si.heightMain);
				thisBaseClip.HLSSelector.gradient.lineTo(si.startX+5*si.widthTemp1, si.startY);
				thisBaseClip.HLSSelector.gradient.endFill();
			//***
				thisBaseClip.HLSSelector.gradient.lineStyle (3,"0x"+clrLite2,0);
				thisBaseClip.HLSSelector.gradient.beginGradientFill("linear", [0x808080,0x808080], [0,100], [0,255], {matrixType:"box", x:3,y:15, w:si.widthMain,h:si.heightMain, r:1.5707963267949});
				thisBaseClip.HLSSelector.gradient.moveTo(si.startX, si.startY);
				thisBaseClip.HLSSelector.gradient.lineTo(si.widthMain+si.startX, si.startY);
				thisBaseClip.HLSSelector.gradient.lineTo(si.widthMain+si.startX, si.heightMain);
				thisBaseClip.HLSSelector.gradient.lineTo(si.startX, si.heightMain);
				thisBaseClip.HLSSelector.gradient.lineTo(si.startX, si.startY);
				thisBaseClip.HLSSelector.gradient.endFill();																
			}
			
		private function squareDrawing(si:Object):Void {
				thisBaseClip.HLSSelector.BorderClip.lineStyle(si.lineWidth,"0x"+si.clrLite2,si.alpha);
				thisBaseClip.HLSSelector.BorderClip.moveTo(1,1);
				thisBaseClip.HLSSelector.BorderClip.lineTo(si.widthMain+2,1);
				thisBaseClip.HLSSelector.BorderClip.lineTo(si.widthMain+2,si.heightMain);
				thisBaseClip.HLSSelector.BorderClip.lineTo(1,si.heightMain);
				thisBaseClip.HLSSelector.BorderClip.lineTo(1,1);
			}
}