/********************************************************
HarmonySchemer class v1.0
Viktor Goltvyanitsa
http://www.fwkit.com
********************************************************/
import com.fwkit.color.ColorRectangle;
import com.fwkit.color.ColorMatch;
class	com.fwkit.color.HarmonySchemer extends MovieClip {
	
	public var schemNames:Object=new Object;
	private var keySchemNames:Array=new Array();
	private var thisWidth:Number;
	private var thisHeight:Number;
	private var rectangleHeight:Number=20;
	private var thisColorBorder:String;
	private var thisThicknessBorder:Number;
	private var harmonyArray:Array=new Array();
	private var drawed:Boolean=false;
	private var startX:Number=0;
	private var startY:Number=15;
	private var startDepth:Number=5;
	private var offset:Number=2;
	public var parentClip:MovieClip;
	private var rectangle1:ColorRectangle;
	private var rectangle2:ColorRectangle;
	private var rectangle3:ColorRectangle;
	private var rectangle4:ColorRectangle;
	private var rectangle5:ColorRectangle;
	private var rectangle6:ColorRectangle;
	private var rectangle7:ColorRectangle;
	private var rectangle8:ColorRectangle;
	private var rectangle9:ColorRectangle;
	private var rectangle10:ColorRectangle;
	private var rectangle11:ColorRectangle;
	private var rectangle12:ColorRectangle;
	private var rectangle13:ColorRectangle;
	private var thisCM:ColorMatch;
	public var thisMovieClip:MovieClip;
	
	
	
	public function HarmonySchemer(thisName:String,thisColorMatch:ColorMatch){
		_name=thisName||"baseHarmony";
		thisCM=thisColorMatch;
		_x=0;
		_y=0;		
	}
	
	public function setClipLink(thisClip:MovieClip):Void{
		thisMovieClip=thisClip;
	}
	
	public function setNameSchemes(currentSchemNames:Object,defaultSchemNames:Array):Void{
		if(currentSchemNames!=undefined&&defaultSchemNames!=undefined&&defaultSchemNames.length==6){
			schemNames.complements=currentSchemNames.complements||defaultSchemNames[0];
			schemNames.split_complements=currentSchemNames.split_complements||defaultSchemNames[1];
			schemNames.triads=currentSchemNames.triads||defaultSchemNames[2];
			schemNames.tetrads=currentSchemNames.tetrads||defaultSchemNames[3];
			schemNames.analogous=currentSchemNames.analogous||defaultSchemNames[4];
			schemNames.monochromatic=currentSchemNames.monochromatic||defaultSchemNames[5];			
		}else{
			schemNames.complements="Complements";
			schemNames.split_complements="Split complements";
			schemNames.triads="Triads";
			schemNames.tetrads="Tetrads";
			schemNames.analogous="Analogous";
			schemNames.monochromatic="Monochromatic";
		}
		keySchemNames=["",schemNames.complements,schemNames.split_complements,schemNames.split_complements,schemNames.triads,schemNames.triads,schemNames.tetrads,schemNames.tetrads,schemNames.tetrads,schemNames.analogous,schemNames.analogous,schemNames.monochromatic,schemNames.monochromatic];
		}
	
	public function drawAll(clipParent:MovieClip,clipWidth:Number,clipHeight:Number,colorBorder:String,thicknessBorder:Number,colorsArray:Array):Void{
		drawed=true;
		parentClip=clipParent;
		thisWidth=clipWidth||150;
		thisHeight=clipHeight||200;
		if(thisWidth<100)thisWidth=100;
		if(thisHeight<100)thisHeight=100;
		
		thisColorBorder=colorBorder||"CCCCCC";
		thisThicknessBorder=thicknessBorder||2;
		if(thisThicknessBorder<1)thisThicknessBorder=1;

		harmonyArray=colorsArray;
		_visible=true;
		_width=thisWidth;
		_parent=clipParent;
		parentClip.createEmptyMovieClip("TextValue",100);
		
		parentClip.TextValue.createTextField("colorValue",-4,3,0,3,3);
		parentClip.TextValue.colorValue.html=true;
		parentClip.TextValue.colorValue.selectable=false;
		parentClip.TextValue.colorValue.multiline=false;
		parentClip.TextValue.colorValue.wordWrap=false;
		parentClip.TextValue.colorValue.autoSize="left";
		setTopTxt();	
		resizeHarmony(thisWidth,thisHeight);
	}
	
	public function setTopTxt(infoText:String):Void{
		if(infoText==undefined)infoText="";
		parentClip.TextValue.colorValue.htmlText="<FONT face='Verdana' size='11'>"+infoText+"</font>";
	}
	
	private function drawRectangle(pointName:String,pointDepth:Number,pointX:Number,pointY:Number,pointWidth:Number,pointColor:String):ColorRectangle{
		parentClip.createEmptyMovieClip(pointName,pointDepth);
		var outRectangle:ColorRectangle = new ColorRectangle(parentClip[pointName],pointX,pointY,thisColorBorder, 80, thisThicknessBorder,pointColor,100,pointWidth, rectangleHeight);
		parentClip[pointName].rgbString=pointColor;
		parentClip[pointName].schemName=keySchemNames[pointDepth];
		parentClip[pointName].thisNumber=pointDepth;
		parentClip[pointName].managerClip=thisMovieClip;
		parentClip[pointName].onRollOver=function(){
			this.useHandCursor = false;
			this.managerClip.setTopTxt("#"+this.rgbString+"  "+this.schemName);
			if(this.thisNumber!=0){
				this.managerClip.setOver(this.thisNumber);
			}
		}
		parentClip[pointName].onRollOut=function(){
			this.useHandCursor = false;
			if(this.thisNumber!=0){
				this.managerClip.setOut(this.thisNumber);
			}
			this.managerClip.setTopTxt();
		}
		parentClip[pointName].onRelease=function(){
			if(this.thisNumber!=0){
				this.managerClip.setRelease(this.thisNumber);
				this.managerClip.setTopTxt("#"+this.rgbString+"  "+this.schemName);
			}else{
				this.managerClip.setOut(this.thisNumber);
			}
		}
		
		return outRectangle;
	}
	
	public function resizeHarmony(totalWidth:Number,totalHeight:Number):Boolean{
		if(drawed==true){
		thisWidth=totalWidth||200;
		thisHeight=totalHeight||120;
		if(thisWidth<100)thisWidth=100;
		if(thisHeight<100)thisHeight=100;
		
		rectangleHeight=(totalHeight-(4*offset)-startY)/5;
		var stepper:Number=0;
		var wRect:Number=(totalWidth/3)-(2*offset);
		this[String("rectangle"+stepper)]=drawRectangle(String("rectangle"+stepper),stepper,startX,startY,thisWidth,harmonyArray[stepper]);
		for(var k=0;k<4;k++){
			for(var m=0;m<3;m++){
				stepper++;
				this[String("rectangle"+stepper)]=drawRectangle(String("rectangle"+stepper),stepper,startX+(m*2.5*offset)+(m*wRect),startY+offset+rectangleHeight+(k*rectangleHeight)+(k*offset),wRect,harmonyArray[stepper]);				
			}
		}			
			return true;
		}else{
			return false;
		}
	}
	
	public function setOver(numClip:Number):Void{
		this[String("rectangle"+numClip)].setOver();
	}
	
	public function setOut(numClip:Number):Void{
		this[String("rectangle"+numClip)].setOut();
	}	
	
	public function setRelease(numClip:Number):Void{
		thisCM.setRGBstr(harmonyArray[numClip]);
		thisCM.createHarmonySchemer(thisMovieClip._parent._parent,thisWidth,thisHeight);
		thisCM.refreshHarmonySchemers();
		this[String("rectangle"+numClip)].setOut();
	}
}