/********************************************************
ArrayUtils class v1.0
Viktor Goltvyanitsa
http://www.fwkit.com
Usage:
			var thisArrayMatch:ArrayUtils=new ArrayUtils();

********************************************************/
class com.fwkit.utils.ArrayUtils {
	public var version:String = "1.0.0.0";
	
	public function ArrayUtils (){}
		
	public function findValueInArray(targetArray:Array,targetValue):Number{
		return getIndex(targetArray, targetValue);
	}
	
	public function getIndex(array, obj):Number {
		var i:Number = array.length;
		while(i--) {
			if (array[i] == obj) return i;
		}
		return -1;
	}
	
	public function cloneArray(targetArray:Array):Array{
		var aTemp:Array = new Array();
		if (targetArray.length == 0) {
				for (var i in targetArray){
					aTemp[i] = targetArray[i]
			}
		}
		for (var i=0; i<targetArray.length; i++) {
			aTemp[i] = targetArray[i]
		}
		return aTemp;
	}
	
	public function deleteItemByIndex(targetArray:Array,indexItem:Number):Array{
		return removeAt(targetArray,indexItem);
	}
	
	public function removeAt(array, index) {
		if (index == 0){
			return array.shift();
		} else if (index == (array.length - 1)){
			return array.pop();
		} else if(index > 0 && index < (array.length - 1)){
			return array.splice(index, 1)[0];
		} 
	}
	
	public function deleteItemByValue(targetArray:Array,itemValue:Number):Array{
		return remove(targetArray, itemValue);
	}
	
	public function remove(array, obj) {
		var i:Number = array.length;
		while(i--) {
			if (array[i] == obj) {
				return array.splice(i,1)[0];	
			}
		}
	}
	
	public function appendArray(array1:Array,array2:Array):Array{
		for(var j=0;j<array2.length;j++){
				array1.push(array2[j]);
		}	
		return array1;
	}
	
	public function randomizeArray(source:Array):Array{
		var tmpArray:Array = [];
		var arrayLength:Number = source.length;
		for (var i = 0; i<arrayLength; i++) {
			var index:Number = Math.floor(Math.random()*source.length);
			tmpArray[i] =source[index];
			deleteItemByIndex(source, index);
		}
		return tmpArray;
	}
}